﻿using System;

namespace producerConsumerState
{
    public class Producer<T>
    {
        private readonly IPutBuffer<T> _buffer; 
        private readonly int _howMany;
        //public static int STOP_VALUE = -1;
        private readonly IItemFactory<T> _factory;

        public Producer(IPutBuffer<T> buffer, int howMany, IItemFactory<T> factory)
        {
            this._buffer = buffer;
            this._howMany = howMany;
            this._factory = factory;
        }

        public void Run()
        {
            for (int i = 0; i < _howMany; i++)
            {
                T element = _factory.CreateItem(i);
                _buffer.Put(element);
                Console.WriteLine("Producer put " + element);
            }
            _buffer.Ending = true;
            Console.WriteLine("Producer is done");
        }
    }
}
