﻿namespace producerConsumer
{
    public interface IBuffer 
    {
        /// <summary>
        /// The number of elements currently in the buffer
        /// </summary>
        int Count { get; }

        /// <summary>
        /// Returns true if the buffer is empty, false otherwise
        /// </summary>
        /// <returns>true if the buffer is empty, false otherwise</returns>
        bool IsEmpty();

        /// <summary>
        /// Removes and returns the first element from this buffer.<br />
        /// If the buffer is empty, the thread calling Tak() must wait until another thread Puts an element.
        /// </summary>
        /// <returns>The first element from this buffer</returns>
        int Take();

        /// <summary>
        /// Adds an element to the end of this buffer.
        /// </summary>
        /// <param name="element">new element to be added to this buffer</param>
        void Add(int element);
    }
}
