﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace producerConsumerGenerics
{
    public abstract class AbstractBuffer<T> : IBuffer<T>
    {
        protected readonly Queue<T> queue = new Queue<T>();
        protected Boolean ending = false;
        protected Boolean ended = false;
        protected readonly String name;

        public AbstractBuffer(String name)
        {
            this.name = name;
        }

        public abstract void put(T element);

        public abstract T take();

        public int Count
        {
            get { return queue.Count; }
        }

        public Boolean isEmpty()
        {
            Monitor.Enter(queue);
            try
            {
                return (queue.Count == 0);
            }
            finally
            {
                Monitor.Exit(queue);
            }
        }

        public Boolean Ending
        {
            get { return ending; }
            set
            {
                Monitor.Enter(queue);
                try
                {
                    ending = value;
                    Console.WriteLine(name + " ending");
                }
                finally
                {
                    Monitor.Exit(queue);
                }
            }
        }

        public Boolean Ended
        {
            get
            {
                Monitor.Enter(queue);
                try
                {
                    return ended;
                }
                finally
                {
                    Monitor.Exit(queue);
                }
            }
        }

    }
}
