﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace producerConsumerGenerics
{
    public class Producer<T>
    {
        private readonly IPutBuffer<T> buffer; 
        private readonly int howMany;
        //public static int STOP_VALUE = -1;
        private readonly ItemFactory<T> factory;

        public Producer(IPutBuffer<T> buffer, int howMany, ItemFactory<T> factory)
        {
            this.buffer = buffer;
            this.howMany = howMany;
            this.factory = factory;
        }

        public void run()
        {
            for (int i = 0; i < howMany; i++)
            {
                T element = factory.createItem(i);
                buffer.put(element);
                Console.WriteLine("Producer put " + element);
            }
            buffer.Ending = true;
            Console.WriteLine("Producer is done");
        }
    }
}
