﻿
using System.Threading;
namespace producerConsumerGenerics
{
    class Program 
    {
        static void Main(string[] args)
        {
            producerMiddlemanConsumer();

        }

        private static ItemFactory<int> integerFactory = new IntegerFactory();
 

        private static void ProducerConsumerUnboundedBuffer()
        {
            IBuffer<int> buffer = new UnboundedBuffer<int>("Buffer");
            Producer<int> producer = new Producer<int>(buffer, 10, integerFactory);
            Consumer<int> consumer = new Consumer<int>(buffer);
            Thread producerThread = new Thread(producer.run);
            Thread consumerThread = new Thread(consumer.run);
            producerThread.Start();
            consumerThread.Start();
        }

        private static void Producer2Consumers()
        {
            IBuffer<int> buffer = new UnboundedBuffer<int>("Buffer");
            Producer<int> producer = new Producer<int>(buffer, 10, integerFactory);
            Consumer<int> consumer = new Consumer<int>(buffer);
            Consumer<int> consumer2 = new Consumer<int>(buffer);

            Thread producerThread = new Thread(producer.run);
            Thread consumerThread = new Thread(consumer.run);
            Thread consumer2Thread = new Thread(consumer2.run);
            producerThread.Start();
            consumerThread.Start();
            consumer2Thread.Start();
        }

        private static void producerMiddlemanConsumer()
        {
            IBuffer<int> buffer1 = new BoundedBuffer<int>("Buffer1", 4);
            IBuffer<int> buffer2 = new BoundedBuffer<int>("Buffer2", 5);
            Producer<int> producer = new Producer<int>(buffer1, 10, integerFactory);
            MiddleMan<int> middleman = new MiddleMan<int>(buffer1, buffer2);
            Consumer<int> consumer = new Consumer<int>(buffer2);
            Thread producerThread = new Thread(producer.run);
            Thread middlemanThread = new Thread(middleman.run);
            Thread consumerThread = new Thread(consumer.run);
            producerThread.Start();
            middlemanThread.Start();
            consumerThread.Start();
        }

        private static void simpleProducerConsumer()
        {
            IBuffer<int> buffer = new BoundedBuffer<int>("Buffer", 40);
            Producer<int> producer = new Producer<int>(buffer, 5, integerFactory);
            Consumer<int> consumer = new Consumer<int>(buffer);
            Thread producerThread = new Thread(producer.run);
            Thread consumerThread = new Thread(consumer.run);
            producerThread.Start();
            consumerThread.Start();
        }
    }
}
