﻿using System;
using System.Collections.Generic;
using System.Threading;

namespace producerConsumer
{
    public abstract class AbstractBuffer : IBuffer
    {
        protected readonly Queue<int> Queue = new Queue<int>();

        public abstract void Put(int element);

        public abstract int Take();

        public int Count
        {
            get { return Queue.Count; }
        }

        public Boolean IsEmpty()
        {
            Monitor.Enter(Queue);
            try
            {
                return (Queue.Count == 0);
            }
            finally
            {
                Monitor.Exit(Queue);
            }
        }
    }
}
